{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit MainJpeg;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, KOL {$IFNDEF KOL_MCK}, mirror, Classes,  Controls, mckCtrls, mckObjs {$ENDIF},
  {$IFDEF JPEGOBJ} JpegObj {$ELSE} KOLJpeg {$ENDIF};
{$ELSE}
{$I uses.inc} mirror,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mirror;
{$ENDIF}

var
  ImagesPath: String = //'c:\KOL\Prj\ImgZoomer\JPEG\';
                       'c:\Images\Pic\Useful\';

//{$DEFINE STRETCHED}
//{$DEFINE NOMASKEDGIF}
//{$DEFINE GIFDECODERONLY}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} {$I Form1class.inc} {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    PaintBox1: TKOLPaintBox;
    Panel1: TKOLPanel;
    BitBtn1: TKOLBitBtn;
    ListBox1: TKOLListBox;
    Splitter1: TKOLSplitter;
    OpenDirDialog1: TKOLOpenDirDialog;
    Label1: TKOLLabel;
    Label2: TKOLLabel;
    Button1: TKOLButton;
    CheckBox1: TKOLCheckBox;
    OpenSaveDialog1: TKOLOpenSaveDialog;
    procedure Button1Click(Sender: PObj);
    procedure PaintBox1Paint(Sender: PControl; DC: HDC);
    procedure KOLForm1Destroy(Sender: PObj);
    procedure Button2Click(Sender: PObj);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure ListBox1SelChange(Sender: PObj);
    procedure CheckBox1Click(Sender: PObj);
  private
    { Private declarations }
  public
    { Public declarations }
    FJpeg: {$IFDEF JPEGOBJ} PJpeg {$ELSE} PKOLJpeg {$ENDIF};
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I MainJpeg_1.inc}
{$ENDIF}

procedure TForm1.Button1Click(Sender: PObj);
begin
  if StrIn( OpenDirDialog1.InitialPath, [ '', '\' ] ) then
    OpenDirDialog1.InitialPath := ImagesPath;
  if OpenDirDialog1.Execute then
  begin
    listbox1.Clear;
    ImagesPath := IncludeTrailingPathDelimiter( OpenDirDialog1.Path );
    listbox1.AddDirList( ImagesPath + '*.jpg', 0 );
    listbox1.AddDirList( ImagesPath + '*.jpeg', 0 );
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: PControl; DC: HDC);
begin
  if FJpeg <> nil then
  begin
    {$IFDEF STRETCHED}
      {$IFDEF GIFDECODERONLY}
        {$IFDEF NOMASKEDGIF}
          FGif.Bitmap.StretchDraw( PaintBox1.Canvas.Handle, PaintBox1.ClientRect );
        {$ELSE}
          //if not FGif.Transparent then
            FGif.Bitmap.StretchDraw( PaintBox1.Canvas.Handle, PaintBox1.ClientRect )
          {else
            FGif.Bitmap.StretchDrawTransparent( PaintBox1.Canvas.Handle,
                        PaintBox1.ClientRect, FGif.BkColor );}
        {$ENDIF}
      {$ELSE}
        //FGif.StretchDrawTransp( PaintBox1.Canvas.Handle, PaintBox1.ClientRect );
        FTiff.StretchDraw( PaintBox1.Canvas.Handle, PaintBox1.ClientRect );
      {$ENDIF}
    {$ELSE}
      FJpeg.Draw( DC, 0, 0 );
      if FJpeg.Bitmap.Width < Sender.Width then
        Sender.Canvas.FillRect( MakeRect( FJpeg.Bitmap.Width, 0, Sender.Width, Sender.Height ) );
      if FJpeg.Bitmap.Height < Sender.Height then
        Sender.Canvas.FillRect( MakeRect( 0, FJpeg.Bitmap.Height, FJpeg.Bitmap.Width, Sender.Height ) );
    {$ENDIF}
  end else
  begin
    PaintBox1.Canvas.FillRect( PaintBox1.ClientRect );
  end;
end;

procedure TForm1.KOLForm1Destroy(Sender: PObj);
begin
  FJpeg.Free;
end;

procedure TForm1.Button2Click(Sender: PObj);
begin
  if FJpeg = nil then Exit;
  if OpenSaveDialog1.Execute then
  begin
    FJpeg.Bitmap := FJpeg.Bitmap;
    FJpeg.CompressionQuality := 85;
    FJpeg.SaveToFile( OpenSaveDialog1.Filename );
  end;
  (*)
  {$IFNDEF GIFDECODERONLY}
  FGif.Frame := FGif.Frame + 1;
  PaintBox1.Invalidate;
  {$ELSE}
  FGif.Frame := FGif.Frame + 1;
  PaintBox1.Invalidate;
  {$ENDIF}
  (*)
  //Label2.Caption := Int2Str( FGif.Frame + 1 ) + '/' + Int2Str( FGif.Count );
end;

procedure AssertErrorHandler(const Message, Filename: string;
  LineNumber: Integer; ErrorAddr: Pointer);
begin
  MsgOK( 'Assertion filed in line # ' + Int2Str( LineNumber ) +
                ' of module ' + FileName + ' :'#13#10 +
                Message );
  Halt;
end;

function InitMyAssert: Boolean;
begin
  AssertErrorProc := @AssertErrorHandler;
  Result := TRUE;
end;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
//var ST: TSystemTime;
begin
  //ShowMessage( Int2Str( SizeOf( TTIFFInfo ) ) + ' ' + Int2Str( SizeOf( TTIFFDirectory ) ) );
  {GetSystemTime( ST );
  ST.wHour := 10;
  SetSystemTime( ST );
  SendMessage( HWND_TOPMOST, WM_TIMECHANGE, 0, 0 );}
  
  //BitBtn1.RepeatInterval := 300;
  Assert( InitMyAssert, '' );
  //Form.CreateWindow;
  listbox1.AddDirList( ImagesPath + '*.gif', 0 );
end;

procedure TForm1.ListBox1SelChange(Sender: PObj);
var S: String;
    w, h: Integer;
begin
  S := ListBox1.Items[ ListBox1.CurIndex ];
    if FJpeg = nil then
      FJpeg := NewJpeg;
    FJpeg.ConvertCMYK2RGB := TRUE;
    FJpeg.Scale := jsFullSize;
    Label1.Caption := '';
    Form.Caption := S;
    TRY
      FJpeg.LoadFromFile( ImagesPath + S );
      if CheckBox1.Checked then
      begin
        w := FJpeg.Width;
        h := FJpeg.Height;
        while (w > 2) and (h > 2) and (FJpeg.Scale < High( TJPEGScale )) and
              ((w > 50) or (h > 50)) do
        begin
          w := w div 2;
          h := h div 2;
          FJpeg.Scale := Succ( FJpeg.Scale );
        end;
        FJpeg.Smoothing := FALSE;
        FJpeg.Performance := jpBestSpeed;
      end
        else
      begin
        FJpeg.Smoothing := TRUE;
        FJpeg.Performance := jpBestQuality;
      end;
      FJpeg.DIBNeeded;
    EXCEPT
      Free_And_Nil( FJpeg );
    END;
    PaintBox1.Invalidate;

    PaintBox1.Update;
    Sleep( 20 );
    (*)
    if FGif.Corrupted then
      Label1.Caption := 'Corrupted';
    PaintBox1.Invalidate;
    {$IFNDEF GIFDECODERONLY}
    if CheckBox1.Checked then
    if FGif.Count > 1 then
    begin
      Timer1.Interval := Max( 10, FGif.Delay[ FGif.Frame ] );
      Timer1.Enabled := TRUE;
    end;
    {$ELSE}
    if CheckBox1.Checked then
    if FGif.Count > 1 then
    begin
      Timer1.Interval := Max( 10, FGif.Frames[ FGif.Frame ].Delay );
      Timer1.Enabled := TRUE;
    end;
    {$ENDIF}
    Label2.Caption := '';
    if FGif.Count > 0 then
    Label2.Caption := Int2Str( FGif.Frame + 1 ) + '/' + Int2Str( FGif.Count );
  (*)
end;

procedure TForm1.CheckBox1Click(Sender: PObj);
begin
  if (ListBox1.CurIndex >= 0) and (ListBox1.Count > 0) then
  ListBox1SelChange(nil);
end;

end.


