{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit MainTiff;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, KOL {$IFNDEF KOL_MCK}, mirror, Classes,  Controls, mckCtrls, mckObjs {$ENDIF},
  KOLTIFF;
{$ELSE}
{$I uses.inc} mirror,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mirror;
{$ENDIF}

var
  ImagesPath: String = 'c:\Images\Tiffs\';

//{$DEFINE STRETCHED}
//{$DEFINE NOMASKEDGIF}
//{$DEFINE GIFDECODERONLY}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} {$I Form1class.inc} {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    PaintBox1: TKOLPaintBox;
    Panel1: TKOLPanel;
    BitBtn1: TKOLBitBtn;
    ListBox1: TKOLListBox;
    Splitter1: TKOLSplitter;
    OpenDirDialog1: TKOLOpenDirDialog;
    Label1: TKOLLabel;
    Label2: TKOLLabel;
    Button1: TKOLButton;
    procedure Button1Click(Sender: PObj);
    procedure PaintBox1Paint(Sender: PControl; DC: HDC);
    procedure KOLForm1Destroy(Sender: PObj);
    procedure Button2Click(Sender: PObj);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure ListBox1SelChange(Sender: PObj);
  private
    { Private declarations }
  public
    { Public declarations }
    FTiff: PTIFF;
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I MainTiff_1.inc}
{$ENDIF}

procedure TForm1.Button1Click(Sender: PObj);
begin
  if StrIn( OpenDirDialog1.InitialPath, [ '', '\' ] ) then
    OpenDirDialog1.InitialPath := ImagesPath;
  if OpenDirDialog1.Execute then
  begin
    listbox1.Clear;
    ImagesPath := IncludeTrailingPathDelimiter( OpenDirDialog1.Path );
    listbox1.AddDirList( ImagesPath + '*.tif', 0 );
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: PControl; DC: HDC);
begin
  if FTiff <> nil then
  begin
    {$IFDEF STRETCHED}
      {$IFDEF GIFDECODERONLY}
        {$IFDEF NOMASKEDGIF}
          FGif.Bitmap.StretchDraw( PaintBox1.Canvas.Handle, PaintBox1.ClientRect );
        {$ELSE}
          //if not FGif.Transparent then
            FGif.Bitmap.StretchDraw( PaintBox1.Canvas.Handle, PaintBox1.ClientRect )
          {else
            FGif.Bitmap.StretchDrawTransparent( PaintBox1.Canvas.Handle,
                        PaintBox1.ClientRect, FGif.BkColor );}
        {$ENDIF}
      {$ELSE}
        //FGif.StretchDrawTransp( PaintBox1.Canvas.Handle, PaintBox1.ClientRect );
        FTiff.StretchDraw( PaintBox1.Canvas.Handle, PaintBox1.ClientRect );
      {$ENDIF}
    {$ELSE}
      FTiff.Draw( DC, 0, 0 );
      if FTiff.Width < Sender.Width then
        Sender.Canvas.FillRect( MakeRect( FTiff.Width, 0, Sender.Width, Sender.Height ) );
      if FTiff.Height < Sender.Height then
        Sender.Canvas.FillRect( MakeRect( 0, FTiff.Height, FTiff.Width, Sender.Height ) );
    {$ENDIF}
  end else
  begin
    PaintBox1.Canvas.FillRect( PaintBox1.ClientRect );
  end;
end;

procedure TForm1.KOLForm1Destroy(Sender: PObj);
begin
  FTiff.Free;
end;

procedure TForm1.Button2Click(Sender: PObj);
begin
  if FTiff = nil then Exit;
  (*)
  {$IFNDEF GIFDECODERONLY}
  FGif.Frame := FGif.Frame + 1;
  PaintBox1.Invalidate;
  {$ELSE}
  FGif.Frame := FGif.Frame + 1;
  PaintBox1.Invalidate;
  {$ENDIF}
  (*)
  //Label2.Caption := Int2Str( FGif.Frame + 1 ) + '/' + Int2Str( FGif.Count );
end;

procedure AssertErrorHandler(const Message, Filename: string;
  LineNumber: Integer; ErrorAddr: Pointer);
begin
  MsgOK( 'Assertion filed in line # ' + Int2Str( LineNumber ) +
                ' of module ' + FileName + ' :'#13#10 +
                Message );
  Halt;
end;

function InitMyAssert: Boolean;
begin
  AssertErrorProc := @AssertErrorHandler;
  Result := TRUE;
end;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
//var ST: TSystemTime;
begin
  //ShowMessage( Int2Str( SizeOf( TTIFFInfo ) ) + ' ' + Int2Str( SizeOf( TTIFFDirectory ) ) );
  {GetSystemTime( ST );
  ST.wHour := 10;
  SetSystemTime( ST );
  SendMessage( HWND_TOPMOST, WM_TIMECHANGE, 0, 0 );}
  
  //BitBtn1.RepeatInterval := 300;
  Assert( InitMyAssert, '' );
  //Form.CreateWindow;
  listbox1.AddDirList( ImagesPath + '*.gif', 0 );
end;

procedure TForm1.ListBox1SelChange(Sender: PObj);
var S: String;
begin
  S := ListBox1.Items[ ListBox1.CurIndex ];
    if FTiff = nil then
      FTiff := NewTIFF;
    Label1.Caption := '';
    Form.Caption := S;
    FTiff.LoadFromFile( ImagesPath + S );
    PaintBox1.Invalidate;
    (*)
    if FGif.Corrupted then
      Label1.Caption := 'Corrupted';
    PaintBox1.Invalidate;
    {$IFNDEF GIFDECODERONLY}
    if CheckBox1.Checked then
    if FGif.Count > 1 then
    begin
      Timer1.Interval := Max( 10, FGif.Delay[ FGif.Frame ] );
      Timer1.Enabled := TRUE;
    end;
    {$ELSE}
    if CheckBox1.Checked then
    if FGif.Count > 1 then
    begin
      Timer1.Interval := Max( 10, FGif.Frames[ FGif.Frame ].Delay );
      Timer1.Enabled := TRUE;
    end;
    {$ENDIF}
    Label2.Caption := '';
    if FGif.Count > 0 then
    Label2.Caption := Int2Str( FGif.Frame + 1 ) + '/' + Int2Str( FGif.Count );
  (*)
end;

end.


