unit ex_zlib;

interface

uses Windows, KOL, KOLZlib;

type PZStreamRec = ^TZStreamRec;

function _inflateInit_( strm: PZStreamRec; Version: PChar; size: Integer ): Integer; cdecl;
function _inflateReset( strm: PZStreamRec ): Integer; cdecl;
function _inflate( strm: PZStreamRec; PartialFlush: Integer ): Integer; cdecl;
function _inflateSync( strm: PZStreamRec ): Integer; cdecl;
function _inflateEnd( strm: PZStreamRec ): Integer; cdecl;

function _deflateInit_( strm: PZStreamRec; level: Integer; Version: PChar; recsize: Integer ): Integer; cdecl;
function _deflateReset( strm: PZStreamRec ): Integer; cdecl;
function _deflate( strm: PZStreamRec; flush: Integer ): Integer; cdecl;
function _deflateEnd( strm: PZStreamRec ): Integer; cdecl;
function _deflateParams( strm: PZStreamRec; level, strategy: Integer ): Integer; cdecl;

implementation

function _inflateInit_( strm: PZStreamRec; Version: PChar; size: Integer ): Integer;
begin
  Result := KOLZLib.inflateInit_( strm^, Version, size );
end;

function _inflateReset( strm: PZStreamRec ): Integer;
begin
  Result := KOLZLib.inflateReset( strm^ );
end;

function _inflate( strm: PZStreamRec; PartialFlush: Integer ): Integer;
begin
  Result := KOLZLib.inflate( strm^, PartialFlush );
end;

function _inflateSync( strm: PZStreamRec ): Integer;
begin
  Result := -3 {Z_DATA_ERROR};
end;

function _inflateEnd( strm: PZStreamRec ): Integer;
begin
  Result := KOLZLib.inflateEnd( strm^ );
end;

function _deflateInit_( strm: PZStreamRec; level: Integer; Version: PChar; recsize: Integer ): Integer;
begin
  Result := KOLZLib.deflateInit_( strm^, level, Version, recsize );
end;

function _deflateReset( strm: PZStreamRec ): Integer;
begin
  Result := KOLZLib.deflateEnd( strm^ );
end;

function _deflate( strm: PZStreamRec; flush: Integer ): Integer;
begin
  Result := KOLZLib.deflate( strm^, flush );
end;

function _deflateEnd( strm: PZStreamRec ): Integer;
begin
  Result := KOLZLib.deflateEnd(strm^);
end;

function _deflateParams( strm: PZStreamRec; level, strategy: Integer ): Integer;
begin
  Result := 0 {Z_OK};
end;

end.
